﻿/*
 * Created by SharpDevelop.
 * User: MICOSUSA
 * Date: 8/13/2010
 * Time: 8:39 AM
 * 
 * Changes to add:
 * add XML command control
 * Timer count down
 * maybe a Timer wizard to help calculate the timer interval
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
 
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Net;
using System.Net.Mail;
//using Excel = Microsoft.Office.Interop.Excel;
using System.IO.Ports;
using System.IO;
using SlimDX.DirectInput;
using System.Threading;

namespace MMC_100_testing
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form{
		string ComPort = "COM9";
		string termread = "";
		string command = "1mvr5";
		string CMD1 = "1pos?";
		string CMD2 = "1sta?";
		string CMD3 = "1mvr-5";
		string CMD4 = "1sta?";
		string CMD5 = "1pos?";
		string delimStr = " #,\n\r";	// delimiters to parse the position
		bool CmdCheck;
		bool timeflag = false;
		bool eOn = false;
		bool joyflag = false;
		char [] delimiter = null;	// char array for the delimiters to parse position reads		
		int CmdCount = 0;
		int cmdcounts = 0;
		int BaudRate = 38400;
		int i =0;
		int j =1;
		int jogVel = 50;
		int jogon = 0;
		int deadband = 5;
		int JoyScale = 2;
		Joystick joy1;
		Joystick[] joy = new Joystick[20];
		DirectInput dinput = new DirectInput();
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			checkJoys();
			
			foreach (string s in SerialPort.GetPortNames()){
		        comboBox1.Items.Add(s);
		    } 
			if (comboBox1.Items.Count >0){
				comboBox1.SelectedIndex = 0;
			}
			comCheck.Start();
			delimiter = delimStr.ToCharArray();

			
			serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived);
			try{
				StreamReader startup = new StreamReader("MMC-APP.ini");
				startup.ReadLine(); //place holder
				if(!int.TryParse(startup.ReadLine(), out BaudRate))
					BAUD.Text = BaudRate.ToString();
				startup.ReadLine();
				CommandBox.Text = startup.ReadLine();
				c1.Text = startup.ReadLine();
				c2.Text = startup.ReadLine();
				c3.Text = startup.ReadLine();
				c4.Text = startup.ReadLine();
				c5.Text = startup.ReadLine();
				startup.ReadLine();
				Time.Text = startup.ReadLine();
				startup.Dispose();
			}catch (ApplicationException e){
				throw new FileNotFoundException("The file could not be read:",e);

			}
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
			

			
		}
		
		private void checkJoys(){
			joySelect.Items.Clear();
			foreach (DeviceInstance device in dinput.GetDevices(DeviceClass.GameController, DeviceEnumerationFlags.AttachedOnly))
			{
				try
				{
					joy[joySelect.Items.Count] = new Joystick(dinput, device.InstanceGuid);
					joySelect.Items.Add( joy[joySelect.Items.Count].Information.InstanceName);
					//break;
				}
				catch (DirectInputException)
				{
				}
			}
			if (joySelect.Items.Count == 0){
				updateTextBox("no Joysticks found");
				joySelect.Enabled = false;
				SelectJoy.Enabled = false;
				JoyDselect.Enabled = false;
			}else{
				
				joySelect.Enabled = true;
				SelectJoy.Enabled = true;
				joySelect.SelectedIndex = 0;
				JoyDselect.Enabled = true;
				
			}
		}
		
		delegate void updateTextBoxDelegate(string newText);
		
		private void updateTextBox(string newText){ 
			if (textBox1.InvokeRequired) {
				updateTextBoxDelegate del = new updateTextBoxDelegate(updateTextBox);     
				textBox1.BeginInvoke(del, new object[] { newText });
			}else {
				textBox1.Text = textBox1.Text.Insert(textBox1.SelectionStart,newText); 
				textBox1.Text = textBox1.Text.Insert(textBox1.SelectionStart, "\r\n");
			}
			i++;
		}
		
		delegate void updateTimerDelegate(string newText);
		
		private void updateTimer(string newText){ 
			if (Time.InvokeRequired) {
				updateTextBoxDelegate del = new updateTextBoxDelegate(updateTimer);
				Time.BeginInvoke(del, new object[] { newText });
			}else {
				Time.Text = "";
				Time.Text = Time.Text.Insert(Time.SelectionStart,newText); 

			}
		}
				
		private void serialWrite( string msg) {
			if (serialPort1.IsOpen){
        		if (serialPort1.BytesToRead<=0){
					System.Text.ASCIIEncoding  encoding = new System.Text.ASCIIEncoding();
					byte[] data = encoding.GetBytes(msg);
					try{
						serialPort1.Write(data, 0, data.Length);
           				serialPort1.Write("\n\r");
					}catch{
						if(eOn){
							sendMail("Serial Write");
							END();
						}
					}
				}else{
					serialPort1.DiscardInBuffer();
				}
			}else{
				serialPort1.PortName=ComPort;
				serialPort1.BaudRate=38400;
				serialPort1.DataBits=8;
				serialPort1.Parity=Parity.None;
				serialPort1.StopBits= StopBits.One;
				try{
					serialPort1.Open();
					updateTextBox("\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r");
					updateTextBox(ComPort+" Open. Begin Testing");
					comboBox1.Enabled = false;
					OpenPort.Enabled = false;
				}catch{
					END();
				}
			}
		}
		
		private void serialPort1_DataReceived (object sender,System.IO.Ports.SerialDataReceivedEventArgs e){
			if (serialPort1.IsOpen) { 
        		int bytes = serialPort1.BytesToRead;
        		byte[] buffer = new byte[bytes];
        		if (serialPort1.BytesToWrite<=0){
        			while(serialPort1.BytesToRead>0){
						try{
							termread = serialPort1.ReadLine();	
							//updateTextBox("MMC: "+termread);						
	        				//serialPort1.Read(buffer, 0, bytes);
	        				//termread =System.Text.Encoding.Default.GetString(buffer);
	        			}catch{
	        				try{
								serialPort1.Open();
								updateTextBox("\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r");
								updateTextBox(ComPort+" Open. Begin Testing");
								comboBox1.Enabled = false;
								OpenPort.Enabled = false;
							}catch{
        						END();
	        				}
	        			}
						updateTextBox("MMC: "+termread);
        			}
				}else{
					updateTextBox("Your port has been disconnected");
        		}
			}
        }
				
		protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
			if (Jogchck.Checked){
				if (keyData == Keys.Left) {
					if(jogon==0){
						serialWrite("0jog-"+jogVel.ToString());
						jogon = 1;
					}else{
						serialWrite("0est");
						jogon = 0;
					}
	            return true;
	       		}
	       		if (keyData == Keys.Right) {
					if(jogon==0){
						serialWrite("0jog"+jogVel.ToString());
						jogon = -1;
					}else{
						serialWrite("0est");
						jogon = 0;
					}
	            return true;
		        }
				if (keyData == Keys.Down) {
					if(jogVel>10){
						jogVel = jogVel-10;
					}else if(jogVel>0){
						jogVel = jogVel-1;
					}
					//serialWrite("0jog"+(jogon*jogVel).ToString());
					updateTextBox(jogVel.ToString());
	            return true;
		        }
				if (keyData == Keys.Up) {
					if(jogVel>=10&&jogVel<100){
						jogVel = jogVel+10;
					}else if(jogVel<100){
						jogVel = jogVel+1;
					}
					//serialWrite("0jog"+(jogon*jogVel).ToString());
					updateTextBox(jogVel.ToString());
	            return true;
		        }
		        return base.ProcessCmdKey(ref msg, keyData);
			}
			return base.ProcessCmdKey(ref msg, keyData);
    }
		
		private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
			END();
        }
		private void END(){
			//DateTime currentSystemTime = DateTime.Now;
			//updateTextBox("serial");
			//updateTextBox(currentSystemTime.ToString());
			//System.Windows.Forms.Application.Exit();
			const string message = "You are about to exit this program, would you like to save your settings for next time?";
			const string caption = "Exiting App";
			var result = DialogResult.Retry;
			result = MessageBox.Show(message, caption,
									MessageBoxButtons.YesNo,
									MessageBoxIcon.Question);
			if (result == DialogResult.Yes)
			{
				try
				{
					string[] outputs = {ComPort,BaudRate.ToString(),"holder",command.ToString(),CMD1.ToString(),CMD2.ToString(),
						CMD3.ToString(),CMD4.ToString(),CMD5.ToString(),"holder",CMDTimer.Interval.ToString()};
					System.IO.File.WriteAllLines(@"MMC-APP.ini", outputs);
					JoyDispose();
					Environment.Exit(0);

				}
				catch (ApplicationException ape)
				{
					throw new FileNotFoundException("The file could not be read:", ape);
				}
			}
			else if (result == DialogResult.No)
			{
				//joy1.Release
				Environment.Exit(1);
			}
		}
           			
		
		void OpenPortClick(object sender, EventArgs e){
			Open();
		}
		
		private void Open(){
			serialPort1.PortName=comboBox1.SelectedItem.ToString();
			serialPort1.BaudRate=BaudRate;
			serialPort1.DataBits=8;
			serialPort1.Parity=Parity.None;
			serialPort1.StopBits= StopBits.One;
			try{
				serialPort1.Open();
				if (serialPort1.IsOpen){
					updateTextBox("\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r");
					updateTextBox("MMC_100: "+ComPort+" Open. Begin Testing");
					comboBox1.Enabled = false;
					OpenPort.Enabled = false;
					Send.Enabled = true;
					TimerOn.Enabled = true;
					comCheck.Stop();
				}
				

			}catch{
				updateTextBox("MMC-100: Try again "+ComPort+" Is Not Valid");
			}
			
		}
		
		void TextBox1TextChanged(object sender, EventArgs e)
		{
			
		}
		
		void CommandBoxTextChanged(object sender, EventArgs e){
			
			if(CommandBox.Text.Contains("\r")){
				serialWrite(command);
				CommandBox.Text = "";
			}else{
				command = CommandBox.Text;
			}
		}
		
		void SendClick(object sender, EventArgs e){
			serialWrite(command);
			
		}
		
		void Button1Click(object sender, EventArgs e)
		{
			serialWrite("0est");
			CMDTimer.Stop();
			TimerOn.Checked=false;
			ReadJoy.Stop();
			serialWrite("0est");
		}
		
		void TimerOnCheckedChanged(object sender, EventArgs e){
			if(CmdCheck){
				CMDTimer.Stop();
				CmdCheck = false;
			}else{
				CMDTimer.Start();
				CmdCheck = true;
			}
			j++;
		}
		
		void C1TextChanged(object sender, EventArgs e){
			CMD1 = c1.Text;
		}
		
		void C2TextChanged(object sender, EventArgs e){
			CMD2 = c2.Text;
		}
		
		void C3TextChanged(object sender, EventArgs e){
			CMD3 = c3.Text;
		}
		
		void C4TextChanged(object sender, EventArgs e){
			CMD4 = c4.Text;
		}
		
		void C5TextChanged(object sender, EventArgs e){
			CMD5 = c5.Text;
		}
		
		void CMDTimerTick(object sender, EventArgs e){
			CMDTimer.Stop();
			if (i>=100){
				textBox1.Clear();
				i = 0;
			}
				if (CmdCount == 0){
					DateTime currentSystemTime = DateTime.Now;
					updateTextBox(currentSystemTime.ToString());
					updateTextBox(command);
					serialWrite(command);
					radioButton2.Checked = true;
				}else if(CmdCount == 1){
					DateTime currentSystemTime = DateTime.Now;
					updateTextBox(currentSystemTime.ToString());
					updateTextBox(CMD1);
					serialWrite(CMD1);
					radioButton3.Checked = true;
				}else if(CmdCount == 2){
					DateTime currentSystemTime = DateTime.Now;
					updateTextBox(currentSystemTime.ToString());
					updateTextBox(CMD2);
					serialWrite(CMD2);
					radioButton4.Checked = true;
				}else if(CmdCount == 3){
					DateTime currentSystemTime = DateTime.Now;
					updateTextBox(currentSystemTime.ToString());
					updateTextBox(CMD3);
					serialWrite(CMD3);
					radioButton5.Checked = true;
				}else if(CmdCount == 4){
					DateTime currentSystemTime = DateTime.Now;
					updateTextBox(currentSystemTime.ToString());
					updateTextBox(CMD4);
					serialWrite(CMD4);
					radioButton6.Checked = true;
				}else if(CmdCount == 5){
					DateTime currentSystemTime = DateTime.Now;
					updateTextBox(currentSystemTime.ToString());
					updateTextBox(CMD5);
					serialWrite(CMD5);
					radioButton1.Checked = true;
				}
				//updateTextBox(CmdCount.ToString());
				CmdCount++;
				cmdcounts++;
				if (CmdCount >5){
					CmdCount = 0;
					DateTime currentSystemTime = DateTime.Now;
					j++;
					updateTextBox("commands: "+cmdcounts.ToString());
				}
			CMDTimer.Start();
			
		}	
		
		void TimeTextChanged(object sender, EventArgs e){
			try{
				CMDTimer.Interval = Int32.Parse(Time.Text);
			}catch{
				updateTextBox("not a valid timer entry");
			}
		}
		
		void FlushTick(object sender, EventArgs e){
			serialPort1.DiscardInBuffer();
			serialPort1.DiscardOutBuffer();
			updateTextBox("BUFFERS FLUSHED");
		}
		
		void FlushbuttonClick(object sender, EventArgs e)
		{
			try{
				serialPort1.DiscardInBuffer();
				serialPort1.DiscardOutBuffer();
				updateTextBox("BUFFERS FLUSHED");
			}catch{}
		}
		
		void CycleClick(object sender, EventArgs e)
		{
			
		}
		
		void BAUDTextChanged(object sender, EventArgs e)
		{
			if(!int.TryParse(BAUD.Text, out BaudRate)) {
                BAUD.BackColor = System.Drawing.Color.Red;
            } else {
                BAUD.BackColor = System.Drawing.Color.White;
            }
		}
		
		void CphTextChanged(object sender, EventArgs e)
		{
			int inter = 0;
			try{
				inter = 600000/Int32.Parse(Cph.Text);
				//CMDTimer.Interval = inter;
				Cph.BackColor = System.Drawing.Color.White;
			}catch{
				Cph.BackColor = System.Drawing.Color.Red;
			}
			CMDTimer.Interval = inter;
			//updateTimer(inter.ToString());
		}
		
		void PerHrCheckedChanged(object sender, EventArgs e)
		{
			if(timeflag ){
				Cph.Enabled = false;
				Time.Enabled = true;
				try{
					CMDTimer.Interval = Int32.Parse(Time.Text);
				}catch{
					updateTextBox("not a valid timer entry");
				}
				timeflag = false;
			}else{
				Cph.Enabled = true;
				Time.Enabled = false;
				try{
					CMDTimer.Interval = 600000/Int32.Parse(Cph.Text);
					Cph.BackColor = System.Drawing.Color.White;
				}catch{
					Cph.BackColor = System.Drawing.Color.Red;
				}
				timeflag = true;
			}
		}
		
		void Send1Click(object sender, EventArgs e)
		{
			serialWrite(CMD1);
		}
		
		void Send2Click(object sender, EventArgs e)
		{
			serialWrite(CMD2);
		}
		
		void Send3Click(object sender, EventArgs e)
		{
			serialWrite(CMD3);
		}
		
		void Send4Click(object sender, EventArgs e)
		{
			serialWrite(CMD4);
		}
		
		void Send5Click(object sender, EventArgs e)
		{
			serialWrite(CMD5);
		}
		
		private void sendMail(string error){
			DateTime currentSystemTime = DateTime.Now;
			MailMessage mail = new MailMessage();
			//string msgBody;
			SmtpClient smtp = new SmtpClient();
			mail.From = new MailAddress("lifesronin@gmail.com", "MMC-100");
			mail.To.Add("cmki31@gmail.com");
			mail.Subject = "Overnight test Tests";
			mail.Body = " an error occured which forced the cycle test to quit unexpectidly. " +
				"The error was cause by:"+ error+"\n\r At:"+currentSystemTime.ToString()+
				"\n\r Commands executed = "+cmdcounts+" \n\r Cycles exectuted = "+cmdcounts/6;
			smtp.Host = "smtp.gmail.com";
			smtp.Port = 587;
			smtp.EnableSsl = true;
			smtp.Credentials = new System.Net.NetworkCredential("lifesronin@gmail.com", "faberd^_^");
			smtp.Send(mail);
		}
			
		void EmailOnCheckedChanged(object sender, EventArgs e)
		{
			if(EmailOn.Checked){
				eOn = true;
			}else{
				eOn = false;
			}
		}
		
		void RadioButton1CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton1.Checked && CmdCount!=5){
				CmdCount = 0;
			}
		}
		
		void RadioButton2CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton2.Checked && CmdCount!=0){
				CmdCount = 1;
			}
		}
		
		void RadioButton3CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton3.Checked&& CmdCount!=1){
				CmdCount = 2;
			}
		}
		
		void RadioButton4CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton4.Checked&& CmdCount!=2){
				CmdCount = 3;
			}
		}
		
		void RadioButton5CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton5.Checked && CmdCount!=3){
				CmdCount = 4;
			}
		}	
		
		void RadioButton6CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton6.Checked && CmdCount!=4){
				CmdCount = 5;
			}
		}
	
		void EXITClick(object sender, EventArgs e)
		{
			END();
		}
		
		void ClearClick(object sender, EventArgs e)
		{
			textBox1.Clear();
			updateTextBox(cmdcounts.ToString());
		}
		
		void ComCheckTick(object sender, EventArgs e)
		{
			bool CBportCheck = false;
			if (comboBox1.Items.Count<1){
				foreach (string port in SerialPort.GetPortNames()){
					comboBox1.Items.Add(port);
				}
			}else{
				try{
					foreach (string CB in comboBox1.Items){
						foreach (string port in SerialPort.GetPortNames()){
							if(!comboBox1.Items.Contains(port)){
								comboBox1.Items.Add(port);
							}
							if(CB == port){
								CBportCheck = true;
							}
						}
						if (!CBportCheck){
							comboBox1.SelectedIndex = 0;
							comboBox1.Items.Remove(CB);
						
						}
						CBportCheck = false;
					}
				}catch{}
			}
		}	
		
		void ComboBox1SelectedIndexChanged(object sender, EventArgs e)
		{
			ComPort	= comboBox1.SelectedItem.ToString();
		}
		
		void ReadJoyTick(object sender, EventArgs e)
		{
			int jog1 = JoyScale*joy1.GetCurrentState().X;
			int jog2 = -1*JoyScale*joy1.GetCurrentState().Y;
			if(jog1<deadband&&jog1>-1*deadband){
				jog1 = 0;
			}
			if(jog2<deadband&&jog2>-1*deadband){
				jog2 = 0;
			}
			if (jog1>100)
				jog1 = 99;
			else if (jog1<-100)
				jog1 = -99;
			if (jog2>100)
				jog2 = 99;
			else if (jog2<-100)
				jog2 = -99;
			
			serialWrite("1JOG"+jog1.ToString()+"; 2JOG"+jog2.ToString());
		}
		
		void JogchckCheckedChanged(object sender, EventArgs e)
		{
			if (Jogchck.Checked&&joyflag){
				ReadJoy.Start();
			}else{
				ReadJoy.Stop();
				serialWrite("0stp");
			}
		}
		
		void JoySelectSelectedIndexChanged(object sender, EventArgs e)
		{
			
		}
		
		void SelectJoyClick(object sender, EventArgs e)
		{
			JoyDselect.Checked = true;
			
		}
		
		void JoyCheckClick(object sender, EventArgs e)
		{
			checkJoys();
		}
		
		public void JoyDispose (){
			if (joy1 != null)
			{
				joy1.Unacquire();
				joy1.Dispose();
			}

			joy1 = null;
		}
		
		void JoyDselectCheckedChanged(object sender, EventArgs e)
		{
			if (JoyDselect.Checked){
				joyAcquire();
			}else{
				ReadJoy.Stop();
				JoyDispose();
				checkJoys();
				if (serialPort1.IsOpen)
					serialWrite("0stp");
			}
		}
		public void joyAcquire(){
			JoyDispose();
			
			foreach (DeviceObjectInstance deviceObject in joy[joySelect.SelectedIndex].GetObjects())
			{
				if ((deviceObject.ObjectType & ObjectDeviceType.Axis) != 0)
					joy[joySelect.SelectedIndex].GetObjectPropertiesById((int)deviceObject.ObjectType).SetRange(-100, 100);
			}

			// Acquire device
			joy1 = joy[joySelect.SelectedIndex];
			joy1.Acquire();
			if (joy1.Acquire().IsFailure)
					throw new Exception("Joystick failure");
			if (joy1.Poll().IsFailure)
					throw new Exception("Joystick failure");
			else{
				updateTextBox(joy1.Information.InstanceName+ " has been selected");
				joyflag = true;
				JoyDselect.Checked = true;
			}
		}


        private void MainForm_Load(object sender, EventArgs e)
        {

        }
    }
}
