﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MicronixMMCLib;
using System.IO.Ports;
using System.Threading;
using System.IO;
using System.Diagnostics;

/*******************************************************************************
 * TO DO: Account for settings that are read but not writte (i.e. sta and vmx) *
 * Only SDF/SAV/WDF axes that are being programmed!                            *
*******************************************************************************/

namespace MMC_Terminal_V1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            button5.Enabled = false;
        }

        //Load Com Ports
        private void comboBox3_MouseDown(object sender, MouseEventArgs e)
        {
            comboBox3.Items.Clear();                                                       //Clear Combo box before adding current valic com ports
            string[] ports = SerialPort.GetPortNames();                                    //Poll Windows for port names
            foreach (string port in ports)                                                 //Iterate through results
            {
                comboBox3.Items.Add(port);                                                 //Add results to combo box menu
            }
        }
        //Connect to selected com port
        private void button1_Click(object sender, EventArgs e)
        {
            if (comboBox3.SelectedItem == null)                                            //Make sure com port selected
            {
                Console.WriteLine("Null Com Port Name");
                return;
            }
            //Port name to string           
            string port = comboBox3.SelectedItem.ToString();

            try
            {
                //Enable control only if com connects succesfully.
                bool isOpen = MicronixMMCLibrary.openComPortMMC(port);
                if (isOpen)
                {
                    comboBox3.Enabled = false;
                    button1.Enabled = false;
                    button5.Enabled = true;

                    //Firmware text update
                    string version_Name = null;
                    version_Name = MicronixMMCLibrary.pollValue("1", "ver");
                    version_Name = MicronixMMCLibrary.cleanText(version_Name);
                    MicronixMMCLibrary.writeCommandToMMC("0","CER");
                    label1.Text = version_Name;
                    label4.Text = "Connected";
                }
            }
            //Alert user if COM port does not connect successfully.
            catch (Exception q)
            {
                MessageBox.Show("This COM port is not available.  Please make sure this com port is not already in use.", "COM Port Not Available", MessageBoxButtons.OK, MessageBoxIcon.Error); ;
            }

        }

        private void button5_Click(object sender, EventArgs e)
        {
            try
            {
                bool isClose = MicronixMMCLibrary.closeComPortMMC();
                if (isClose)
                {
                    label1.Text = "Firmware Name";
                    label4.Text = "Not Connected";
                    comboBox3.Enabled = true;
                    button5.Enabled = false;
                    button1.Enabled = true;
                }
            }
            //Alert user if COM port does not disconnect successfully.
            catch (Exception g)
            {
                MessageBox.Show("This COM port is busy.  Please make sure this com port idle before disconnecting.", "COM Port Not Disconnecting", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string output = null;
            string newline = Environment.NewLine;
            if( !String.IsNullOrWhiteSpace(comboBox1.SelectedItem.ToString() ) && !String.IsNullOrWhiteSpace(textBox2.Text) )
            {
                textBox3.AppendText(comboBox1.SelectedItem.ToString() + textBox2.Text + "?" + newline);
                output = MicronixMMCLibrary.pollValue(comboBox1.SelectedItem.ToString(), textBox2.Text);
                output = MicronixMMCLibrary.cleanText(output);
                textBox3.AppendText(">> " + output + newline);
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            string newline = Environment.NewLine;
            if (!String.IsNullOrWhiteSpace(comboBox2.SelectedItem.ToString()) && !String.IsNullOrWhiteSpace(textBox4.Text))
            {
                MicronixMMCLibrary.writeCommandToMMC(comboBox2.SelectedItem.ToString(), textBox4.Text);
                textBox3.AppendText(comboBox2.SelectedItem.ToString() + textBox4.Text + newline);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            textBox3.Clear();
        }
    }
}